<template>
	<div>
		
		<div class="alert alert-success" v-if="success">
			<span v-text="success"></span>
		</div>

		<div class="alert alert-danger" v-if="errors">
			<span v-for="error in errors" v-text="error[0]" class="d-block"></span>
		</div>

		<form action="" @submit.prevent="submit_form">
			<div class="form-group">
				<label for="">Título</label>
				<input type="text" v-model="title" class="form-control" required>
			</div>

			<div class="form-group">
				<label for="">Subtítulo</label>
				<input type="text" v-model="subtitle" class="form-control">
			</div>
		
			<div class="form-group">
				<label for="">Contenido de la página</label>
				<vue-editor v-model="body" placeholder="Contenido de página" />
			</div>

			<div class="form-group">
				<div class="custom-control custom-switch">
					<input type="checkbox" v-model="status_id" class="custom-control-input" id="pageStatusSwitch">
					<label class="custom-control-label" for="pageStatusSwitch">Publicar página al guardar</label>
				</div>
			</div>

			<button type="submit" ref="submit_btn" class="btn btn-primary mt-4">
				<span class="spinner-border spinner-border-sm mr-2" v-if="submiting"></span>
				<span v-if="page">Actualizar</span> 
				<span v-else>Guardar</span> 
				página
			</button>
		</form>

	</div>
</template>
<script>

	import { VueEditor } from "vue2-editor";

	export default {
		props: ['page'],
		components: {VueEditor},
		data(){
			return {
				title: this.page ? this.page.title : '',
				subtitle: this.page ? this.page.subtitle : '',
				body: this.page ? this.page.body : '',
				success: null,
				errors: null,
				submiting: false,
				status_id: 1
			}
		},
		methods: {
			submit_form(){
				let t = this;
				let url = t.page ? '/dashboard/pages/' + t.page.id : '/dashboard/pages';
				let btn = t.$refs.submit_btn;
				let view_title = document.querySelector('#viewTitle');
				btn.setAttribute('disabled', 'disabled');
				t.errors = null;
				t.success = null;
				t.submiting = true;
				axios.post(url, {
					title: t.title,
					subtitle: t.subtitle,
					body: t.body,
					_method: t.page ? 'PATCH' : 'POST'
				}).then(({data}) => {
					btn.removeAttribute('disabled');
					t.success = data.msg;
					view_title.scrollIntoView({behavior: 'smooth'});
					t.submiting = false;
				}).catch((error) => {
					t.errors = error.response.data.errors;
					btn.removeAttribute('disabled');
					view_title.scrollIntoView({behavior: 'smooth'});
					t.submiting = false;
				});
			}
		}

	}

</script>